<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use JsonSerializable;

/**
 * Implementation for the base of an entity: id
 */
trait TBaseEntity {
    /**
     * @var int|null The internal id
     *
     * @noinspection PhpPropertyNamingConventionInspection
     */
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    /**
     * The internal id
     *
     * @return int|null The internal id
     */
    public function getId (): ?int {
        return $this->id;
    }
}